<template>
  <div v-if="loadingCreate == true" class="container loading">
    <v-progress-circular indeterminate color="#16abf8"></v-progress-circular>
  </div>
  <div class="container" v-else>
    <div class="todo-header" data-cy="activity-item">
      <v-row class="mt-5" data-cy="activity-title">
        <div class="mt-5 icon-back" data-cy="todo-back-button">
          <router-link to="/" style="text-decoration: none"><v-icon large>mdi-chevron-left</v-icon></router-link>
        </div>
        <div>
          <v-text-field
            data-cy="todo-title"
            :value="detailActivity.title"
            :v-model="detailActivity.title"
            style="padding-top: 0; font-weight: 700"
            @input="dataInput = $event"
            v-click-outside="{
              handler: onClickOutsideWithConditional,
              closeConditional,
            }"
            @click="models.conditional = true"
          ></v-text-field>
        </div>
        <span class="icon-edit cursor-pointer" data-cy="todo-title-edit-button" @click="update()" style="margin-top: 15px"
          ><v-icon medium color="#c1c1c1">mdi-border-color</v-icon></span
        >
      </v-row>
      <v-menu offset-y down style="width: 320px !important">
        <template v-slot:activator="{ on, attrs }">
          <span class="jjj cursor-pointer" v-bind="attrs" v-on="on">
            <img src="@/assets/arrows-sort.svg" alt="arrows-sort" class="img-arrow" />
          </span>
        </template>
        <v-list data-cy="todo-sort-button">
          <v-list-item-group v-model="model">
            <v-list-item @click="getFilter(row.id)" v-for="(row, index) in listSort" :key="index"
              ><v-list-item :data-cy="idSort == 1 ? 'sort-selection-selected' : 'false'">
                <v-icon color="#16abf8" class="mr-25" data-cy="sort-selection-icon">{{ row.icon }}</v-icon
                ><v-list-item-title data-cy="sort-selection-title">{{ row.name }}</v-list-item-title>
                <!-- <v-icon class="ml-25" v-if="idSort == model">mdi-check</v-icon> -->
              </v-list-item></v-list-item
            >
          </v-list-item-group>
        </v-list>
      </v-menu>

      <v-btn data-cy="todo-add-button" color="#16abf8" class="btn-add" height="54" @click="openDialog()"
        ><v-icon class="text-white">mdi-plus</v-icon><span class="text-white">Tambah</span></v-btn
      >
    </div>
    <div class="detail-content">
      <div v-if="listItems.length > 0">
        <v-row>
          <v-col v-for="(row, index) in listItems" :key="index" md="12">
            <v-card class="mx-auto" elevation="2" data-cy="todo-item">
              <v-card-text class="content-item" style="padding: 27px; border-radius: 12px">
                <v-row>
                  <div class="col-md-9 form-check">
                    <v-row>
                      <div style="margin-right: 10px">
                        <v-checkbox
                          :input-value="getCheck(row.is_active)"
                          @click="getLine(row)"
                          color="#16abf8"
                          data-cy="todo-item-checkbox"
                          :value="row.is_active"
                        ></v-checkbox>
                      </div>
                      <div style="display: flex; margin-right: 10px">
                        <v-icon :color="getColor(row.priority)" data-cy="todo-item-priority-indicator">mdi-circle</v-icon>
                      </div>
                      <div :class="row.is_active == 0 ? 'line mid' : 'mid'">
                        <h4 data-cy="todo-item-title">
                          {{ row.title }}
                        </h4>
                      </div>
                      <span class="icon-edit cursor-pointer mid" data-cy="todo-item-edit-button" @click="editData(row)"
                        ><v-icon medium color="#c1c1c1">mdi-border-color</v-icon></span
                      >
                    </v-row>
                  </div>
                  <div class="col-md-3 icon-delete">
                    <v-icon color="#888" class="cursor-pointer" data-cy="todo-item-delete-button" @click="openDialogDelete(row)"
                      >mdi-trash-can-outline</v-icon
                    >
                  </div>
                </v-row>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </div>
      <div v-else>
        <div md="12" data-cy="todo-empty-state" @click="openDialog()" class="cursor-pointer">
          <img src="@/assets/todo-empty.png" alt="activity empty state" />
        </div>
      </div>
    </div>
    <DialogAddTodo :is-open.sync="dialog"></DialogAddTodo>
    <DialogDeleteTodo :dialog-tutup.sync="dialogTodo" :data-delete="deleteTodo"></DialogDeleteTodo>
    <DialogEditTodo :open-edit.sync="dialogEdit" :data-edit="deleteTodo"></DialogEditTodo>
    <v-dialog v-model="status1" max-width="500" data-cy="modal-information" class="box-card">
      <v-card class="modal-content">
        <div class="modal-body-information">
          <v-card-text>
            <v-row>
              <div data-cy="modal-information-icon" class="icon-alert-sm"><v-icon color="#13d67c">mdi-alert-circle-outline</v-icon></div>
              <div data-cy="modal-information-title" class="fz-16"><p>Todo berhasil dihapus</p></div>
            </v-row>
          </v-card-text>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import DialogAddTodo from "@/components/dialog-add-todo.vue";
import DialogDeleteTodo from "@/components/dialog-delete.todo.vue";
import DialogEditTodo from "@/components/dialog-edit-todo.vue";
export default {
  name: "HomeView",
  components: {
    DialogAddTodo,
    DialogDeleteTodo,
    DialogEditTodo,
  },
  data() {
    return {
      models: {
        base: false,
        conditional: false,
      },
      model: 1,
      edit: false,
      dataInput: "",
      dialog: false,
      checkbox: [],
      dataFilter: [],
      deleteTodo: {},
      dialogTodo: false,
      dialogEdit: false,
      idSort: 1,
      idCy: true,
      listSort: [
        { id: 1, icon: "mdi-sort-ascending", name: "Terbaru" },
        { id: 2, icon: "mdi-sort-descending", name: "Terlama" },
        { id: 3, icon: "mdi-sort-alphabetical-ascending", name: "A-Z" },
        { id: 4, icon: "mdi-sort-alphabetical-descending", name: "Z-A" },
        { id: 5, icon: "mdi-arrow-up-down", name: "Belum Selesai" },
      ],
      items: [
        { id: 1, color: "#ed4c5c", name: "Very High", value: "very-high" },
        { id: 2, color: "#f8a541", name: "High", value: "high" },
        { id: 3, color: "#00a790", name: "Medium", value: "normal" },
        { id: 4, color: "#428bc1", name: "Low", value: "low" },
        { id: 5, color: "#8942c1", name: "Very Low", value: "very-low" },
      ],
    };
  },
  mounted() {
    this.getDetailActivity(this.$route.params.id);
  },
  methods: {
    ...mapActions(["getDetailActivity", "updateActivity", "updateStatus"]),
    onClickOutsideWithConditional() {
      this.update();
    },
    closeConditional() {
      return this.models.conditional;
    },
    getAdd() {
      this.postActivity();
    },
    update() {
      const params = {
        id: this.$route.params.id,
        title: this.dataInput,
      };
      this.updateActivity(params);
      this.edit = false;
    },
    inputData() {
      this.edit = true;
    },
    openDialog() {
      this.dialog = true;
    },
    getColor(name) {
      const color = this.items.filter((ele) => ele.value == name);
      const warna = Object.assign({}, ...color);
      return warna.color;
    },
    openDialogDelete(row) {
      this.deleteTodo = row;
      this.dialogTodo = true;
    },
    editData(row) {
      this.dialogEdit = true;
      this.deleteTodo = row;
    },
    getLine(row) {
      this.updateStatus(row);
    },
    getCheck(row) {
      if (row == 0) {
        return true;
      } else {
        return false;
      }
    },
    getFilter(id) {
      if (id == 1) {
        this.listItems.sort((a, b) => b.id - a.id);
      } else if (id == 2) {
        this.listItems.sort((a, b) => a.id - b.id);
      } else if (id == 3) {
        this.listItems.sort(function (a, b) {
          if (a.title < b.title) {
            return -1;
          }
          if (a.title > b.title) {
            return 1;
          }
          return 0;
        });
      } else if (id == 4) {
        this.listItems.sort(function (a, b) {
          if (a.title > b.title) {
            return -1;
          }
          if (a.title < b.title) {
            return 1;
          }
          return 0;
        });
      } else {
        this.listItems.sort((a, b) => b.id - a.id);
      }
    },
  },
  computed: {
    ...mapGetters(["listItems", "detailActivity", "loadingCreate", "status1"]),
  },
};
</script>
<style>
.theme--light.v-card > .v-card__subtitle,
.theme--light.v-card > .v-card__text {
  color: black;
  display: flex;
  justify-content: space-between !important;
  background-color: #fff;
  margin-bottom: 10px !important;
  border-radius: 12px !important;
  box-shadow: 0 4px 8px rgb(0 0 0 / 15%);
}

.line {
  text-decoration: line-through;
  color: #c1c1c1;
}
.mid {
  display: flex;
  align-self: center;
}
.jjj {
  border-radius: 50%;
  border: 1px solid #e5e5e5;
  background-color: transparent;
  height: 54px;
  width: 54px;
  margin-right: 18px;
}
.mr-25 {
  margin-right: 25px;
}
.ml-25 {
  margin-left: 25px;
}
.v-menu__content {
  width: 250px;
}
</style>
